set names WIN1251;
set CLIENTLIB 'fbclient.dll';
connect 'd:\Smarket.fdb' user 'sysdba' password '3';

insert into scripts(name, makedate, developer, comment1)
  values('FB1402_quart_18_4_add2.sql', '31.01.2019', 14, '       IV  2018 ');


set term ^ ;


create or alter procedure EGAIS_CHECK_CARD_CAPACITY (
    ARTICUL T_ARTICUL)
returns (
    RESULT T_INT_VALUE)
AS
begin
  select count(distinct iif(c.CAPACITY is null or abs(c.CAPACITY) < 1e-9, -1, 1))
    from EGAIS_CARDS_LINK k
    join EGAIS_CARDS c on c.ALC_CODE = k.ALC_CODE
   where k.ARTICUL = :ARTICUL
    into :RESULT;

  suspend;
end^

-- .          ,   .
--      1375.
create or alter procedure EGAIS_MAKE_ACTS_FROM_CASH (
    UTM           T_ID,
    PERIOD_START  T_DATE,
    PERIOD_FINISH T_DATE,
    MAKE_WRITEOFF T_INT_BOOLEAN = 1,
    MAKE_CHARGEON T_INT_BOOLEAN_NULL = null)
returns (
    ID_WRITEOFF T_DOC,
    ID_CHARGEON T_DOC,
    ERROR_MSG   T_LONG_STR)
AS
declare variable ALC_CODE       T_EGAIS_CODE;
declare variable ARTICUL        T_ARTICUL_NULL;
declare variable CONSIGNOR_TYPE integer;
declare variable DOC            integer;
declare variable POSW           integer;
declare variable POSC           integer;
declare variable PRICE          double precision;
declare variable REMAINS        double precision;
declare variable Q              double precision;
declare variable QUANTITY       double precision;
declare variable UNMARK         integer;
declare variable UNMARK2        integer;
declare variable USE_RETURNS    char;

declare variable CASHDOC_COUNT integer; --      ( )
declare variable UNMARK1_COUNT integer; --  "" 
declare variable ALCCODE_COUNT integer; --  ,   
declare variable UNMARK2_COUNT integer; --  ,   "" 
declare variable CAP_COUNT     integer;
declare variable CAPACITY      double precision;
begin
  --     ()     () 2 
  --        (),    ().
  in autonomous transaction do
    insert into TMP_LOG (KIND, level, TEXT)
         values (1, 3, '  2     "  "   ' || :PERIOD_START || ' - ' || :PERIOD_FINISH);

  ID_WRITEOFF = null;
  ID_CHARGEON = null;
  POSW = 0;
  POSC = 0;
  CASHDOC_COUNT = 0;
  UNMARK1_COUNT = 0;
  UNMARK2_COUNT = 0;
  ALCCODE_COUNT = 0;

  --   "      "
  select NUMPARAM
    from CONFIG
   where PARAMNAME = 'EGAISConsignorSell'
    into :CONSIGNOR_TYPE;

  --  " "
  select BOOLPARAM
    from CONFIG
   where PARAMNAME = 'EGAISCashboxUseReturns'
    into :USE_RETURNS;


  --  MAKE_CHARGEON   ,    
  if (MAKE_CHARGEON is null) then
    MAKE_CHARGEON = iif(exists(select 1
                                 from CONFIG
                                where PARAMNAME = 'EGAISCashboxMakeChargeOn'
                                      and BOOLPARAM = 'T'), 1, 0);

  in autonomous transaction do
    insert into TMP_LOG (KIND, level, TEXT)
         values (1, 5, 'EGAISConsignorSell: ' || :CONSIGNOR_TYPE || '  MAKE_WRITEOFF: ' || :MAKE_WRITEOFF || '  MAKE_CHARGEON: ' || :MAKE_CHARGEON || ' USE_RETURNS: ' || :USE_RETURNS);

  --    ,    ,     .
  --    ,   .
  delete from TMP_EGAIS_CASH_DATA where 1=1;

  for
    select ds.ARTICUL, dh.ID_DOCHEAD, ds.PRICERUB,
           decode(dh.DOCTYPE, 1001, ds.QUANTITY, 1000, -ds.QUANTITY) --   "+",   "-"
      from DOCHEAD dh
      join DOCSPEC ds on ds.ID_DOCHEAD = dh.ID_DOCHEAD
      left join SUPERPLACE sp on sp.PLACEINDEX = dh.CLIENT2_INDEX
                             and sp.SPKIND = 12
                             and sp.IS_USED = 'T'
      left join SUPERPLACE_HEAD sh on sh.ID = sp.ID
                                  and sh.IS_USED = 'T'
     where dh.DOC_DATE between :PERIOD_START and :PERIOD_FINISH
           and (dh.DOCTYPE = 1001 --  
                or (:USE_RETURNS = 'T' and dh.DOCTYPE = 1000)) --    (  )
           and dh.ACCEPT = 'T'
           and ((:CONSIGNOR_TYPE = 0 and :UTM = dh.LEGAL_PERSON)
                or (:CONSIGNOR_TYPE = 1 and :UTM = sh.CLIENT_INDEX)
                or (:CONSIGNOR_TYPE = 2 and
                           ((sh.CLIENT_INDEX is not null and sh.CLIENT_INDEX = :UTM)
                             or (sh.CLIENT_INDEX is null and dh.LEGAL_PERSON = :UTM)))
                or (:CONSIGNOR_TYPE = 3 and
                           ((nullif(dh.LEGAL_PERSON,-1) is not null and dh.LEGAL_PERSON = :UTM)
                             or (nullif(dh.LEGAL_PERSON,-1) is null and sh.CLIENT_INDEX = :UTM))))
      into :ARTICUL, :DOC, :PRICE, :QUANTITY     -- PRICE ,   ,  ,  
  do
  begin
    CASHDOC_COUNT = CASHDOC_COUNT + 1;

    select v.UNMARK
      from CARDPARAMS p
      join VID_PROD v on v.ID = p.PARAMVALUE
     where p.ARTICUL = :ARTICUL
       and p.PARAMTYPE = 7
      rows 1
      into :UNMARK;

    if (UNMARK = 1) then
    begin
      UNMARK1_COUNT = UNMARK1_COUNT + 1;

      select RESULT
        from EGAIS_CHECK_CARD_CAPACITY(:ARTICUL)
        into :CAP_COUNT;
    
      if (CAP_COUNT > 1) then
      begin
        ERROR_MSG = ' <'||:ARTICUL||'>    ,    .';
        suspend;
        in autonomous transaction do
          insert into TMP_LOG (KIND, level, TEXT) values (1, 1, :ERROR_MSG);
        exit;
      end

      select k.ALC_CODE, v.UNMARK, coalesce(c.CAPACITY,0)
        from EGAIS_CARDS_LINK k
        left join EGAIS_CARDS c on c.ALC_CODE = k.ALC_CODE
        left join VID_PROD v on upper(v.kod collate PXW_CYRL) = c.PRODUCT_VCODE
       where k.ARTICUL = :ARTICUL
       order by v.UNMARK desc nulls last
        rows 1
        into :ALC_CODE, :UNMARK2, :CAPACITY;

      --   ,   
      if (CAPACITY = 0) then
      begin
        QUANTITY = QUANTITY / 10;-- ; 
        PRICE = PRICE * 10;
      end


      if (ALC_CODE is not null) then
        ALCCODE_COUNT = ALCCODE_COUNT + 1;

      if (UNMARK2 = 1) then
        UNMARK2_COUNT = UNMARK2_COUNT + 1;

      if (abs(QUANTITY) > 1e-9 and ALC_CODE is not null and UNMARK2 = 1) then
      begin
        if (exists(select 1 from TMP_EGAIS_CASH_DATA where ARTICUL = :ARTICUL)) then
          update TMP_EGAIS_CASH_DATA
             set QUANTITY = QUANTITY + :QUANTITY,
                 PRICE    = PRICE    + :PRICE * :QUANTITY
           where ARTICUL = :ARTICUL;
        else
          insert into TMP_EGAIS_CASH_DATA values (:ARTICUL, :QUANTITY, :PRICE * :QUANTITY);
  
        in autonomous transaction do
          insert into TMP_LOG (KIND, level, TEXT)
               values (1, 5, '  :  '||:DOC||'  '||:ARTICUL||'  '||doubletrunc(:QUANTITY,'0.00')||'  '||doubletrunc(:PRICE,'0.00'));
      end
    end
  end

  --   ,   
  if (CASHDOC_COUNT = 0) then
  begin
    ERROR_MSG = '      .';
    suspend;
    if (ERROR_MSG is not null) then
      in autonomous transaction do
        insert into TMP_LOG (KIND, level, TEXT) values (1, 1, :ERROR_MSG);
    exit;
  end

  if (UNMARK1_COUNT = 0) then
  begin
    ERROR_MSG = '        .';
    suspend;
    if (ERROR_MSG is not null) then
      in autonomous transaction do
        insert into TMP_LOG (KIND, level, TEXT) values (1, 1, :ERROR_MSG);
    exit;
  end

  if (ALCCODE_COUNT = 0) then
  begin
    ERROR_MSG = '    ,    ';
    suspend;
    if (ERROR_MSG is not null) then
      in autonomous transaction do
        insert into TMP_LOG (KIND, level, TEXT) values (1, 1, :ERROR_MSG);
    exit;
  end

  if (UNMARK2_COUNT = 0) then
  begin
    ERROR_MSG = '    ,        .';
    suspend;
    if (ERROR_MSG is not null) then
      in autonomous transaction do
        insert into TMP_LOG (KIND, level, TEXT) values (1, 1, :ERROR_MSG);
    exit;
  end



  for
    select ARTICUL, QUANTITY, PRICE
      from TMP_EGAIS_CASH_DATA
      into :ARTICUL, :QUANTITY, :PRICE
  do
      in autonomous transaction do
        insert into TMP_LOG (KIND, level, TEXT)
             values (1, 5, ' :  '||:ARTICUL||'  '||doubletrunc(:QUANTITY,'0.00')||'  '||doubletrunc(:PRICE,'0.00'));

  delete from TMP_EGAIS_CASH_DATA where abs(QUANTITY) < 1e-9; --          .

  for
    select ARTICUL, QUANTITY, PRICE/QUANTITY   -- PRICE ,   ,  ,  
      from TMP_EGAIS_CASH_DATA
      into :ARTICUL, :QUANTITY, :PRICE         --   PRICE   
  do
  begin
    if (PRICE < 0) then PRICE = 0; --     () 

    in autonomous transaction do
      insert into TMP_LOG (KIND, level, TEXT)
           values (1, 5, ':  ' || :ARTICUL || '   ' || DOUBLETRUNC(:QUANTITY, '0.00'));

    for
      select ALC_CODE, QUANTITY
        from (
              select k.ALC_CODE, r.QUANTITY, 1 as POS
                from EGAIS_CARDS_LINK k
                join EGAIS_CARDS c on c.ALC_CODE = k.ALC_CODE
                join EGAIS_REMAINS R on r.ALC_CODE = k.ALC_CODE
                                    and r.REGISTER = 2
                                    and r.UTM = :UTM
                                    and (r.QUANTITY > 0 or :QUANTITY < 0) --     ,     
               where k.ARTICUL = :ARTICUL
                 and c.PRODUCT_VCODE in (select KOD
                                           from VID_PROD
                                          where UNMARK = 1) -- 
      
              union
      
              select ALC_CODE, QUANTITY, 2 as POS
                from (
                      select k.ALC_CODE, 1e9 as QUANTITY
                        from EGAIS_CARDS_LINK k
                        join EGAIS_CARDS c on c.ALC_CODE = k.ALC_CODE
                        left join EGAIS_REMAINS R on r.ALC_CODE = k.ALC_CODE
                                                 and r.REGISTER = 2
                                                 and r.UTM = :UTM
                                                 and (r.QUANTITY > 0 or :QUANTITY < 0)
                       where k.ARTICUL = :ARTICUL
                         and c.PRODUCT_VCODE in (select KOD
                                                   from VID_PROD
                                                  where UNMARK = 1) -- 
                       order by r.QUANTITY desc --   ;     
                        rows 1
                     )
             )
       order by POS
       --              (       ).
       --          (),
       --        .        .
       --     ,       . .
        into :ALC_CODE, :REMAINS
    do
    begin
      in autonomous transaction do
        insert into TMP_LOG (KIND, level, TEXT)
             values (1, 5, ':  ' || :ALC_CODE || '   ' || iif(:REMAINS > 1e8, '', DOUBLETRUNC(:REMAINS, '0.00')));

      if (QUANTITY > 1E-9 and MAKE_WRITEOFF = 1) then -- 
      begin
        if (ID_WRITEOFF is null) then
        begin
          insert into EGAIS_REG2_DOCHEAD (OWNER, KIND, DOC_KIND, DOC_ID, REASON, EGAIS_STATE) --    2 ,
               values (:UTM, 2, 5, null, 11, 1) -- -:  - 5,  - 
            returning (ID)
                 into :ID_WRITEOFF;

          in autonomous transaction do
            insert into TMP_LOG (KIND, level, TEXT)
                 values (1, 5, ' 2: ' || :ID_WRITEOFF);
        end


        -- !      ,       .
        --     ,      .    ,    ,
        --    .      .
        --   ,      .     .
        --       :
        Q = minvalue(:QUANTITY, :REMAINS);
        --    ,    ,    (   ).     .
        -- -         ,      .
        --     :
        --Q = QUANTITY;

        --  .
        -- ,      ,      .
        --       ,  .
        --     .
        --         .

        --   (  )
        if (exists(select 1
                     from EGAIS_REG2_SPEC
                    where DOC_ID = :ID_WRITEOFF
                          and ARTICUL = :ARTICUL)) then
          update EGAIS_REG2_SPEC
             set QUANTITY = QUANTITY + :Q
                 -- PRICE = ((PRICE * QUANTITY) + (:PRICE * :Q)) / (QUANTITY + :Q)
           where DOC_ID = :ID_WRITEOFF
             and ARTICUL = :ARTICUL;
        else
          insert into EGAIS_REG2_SPEC (DOC_ID, ARTICUL, QUANTITY, PRICE)
               values (:ID_WRITEOFF, :ARTICUL, :Q, :PRICE);

        --   (  )
        if (exists(select 1
                     from EGAIS_REG2_SPEC_EXT
                    where DOC_ID = :ID_WRITEOFF
                          and ARTICUL = :ARTICUL
                          and ALC_CODE = :ALC_CODE)) then
          update EGAIS_REG2_SPEC_EXT
             set QUANTITY = QUANTITY + :Q
           where DOC_ID = :ID_WRITEOFF
             and ARTICUL = :ARTICUL
             and ALC_CODE = :ALC_CODE;
        else
        begin
          POSW = POSW + 1;
          insert into EGAIS_REG2_SPEC_EXT (DOC_ID, ARTICUL, ALC_CODE, QUANTITY, IDENTITY)
               values (:ID_WRITEOFF, :ARTICUL, :ALC_CODE, :Q, :POSW);
        end

        in autonomous transaction do
          insert into TMP_LOG (KIND, level, TEXT)
               values (1, 5, '   : / '||:ALC_CODE||'  '||doubletrunc(:Q,'0.00'));

        QUANTITY = QUANTITY - Q;
      end


      if (QUANTITY < -1E-9 and MAKE_CHARGEON = 1) then --   
      begin
        if (ID_CHARGEON is null) then
        begin
          insert into EGAIS_REG2_DOCHEAD (OWNER, KIND, DOC_KIND, DOC_ID, REASON, EGAIS_STATE) --    2 ,
               values (:UTM, 1, 5, null, 2, 1) -- -:  - 5,  - 
            returning (ID)
                 into :ID_CHARGEON;

          in autonomous transaction do
            insert into TMP_LOG (KIND, level, TEXT)
                 values (1, 5, ' 2: ' || :ID_CHARGEON);
        end

        --   .     .
        --Q = minvalue(-:QUANTITY, :REMAINS);
        Q = -QUANTITY;

        --   (  )
        if (exists(select 1
                     from EGAIS_REG2_SPEC
                    where DOC_ID = :ID_CHARGEON
                          and ARTICUL = :ARTICUL)) then
          update EGAIS_REG2_SPEC
             set QUANTITY = QUANTITY + :Q
                 -- PRICE = ((PRICE * QUANTITY) + (:PRICE * :Q)) / (QUANTITY + :Q)
           where DOC_ID = :ID_CHARGEON
             and ARTICUL = :ARTICUL;
        else
          insert into EGAIS_REG2_SPEC (DOC_ID, ARTICUL, QUANTITY, PRICE)
               values (:ID_CHARGEON, :ARTICUL, :Q, :PRICE);


        --   (  )
        if (exists(select 1
                     from EGAIS_REG2_SPEC_EXT
                    where DOC_ID = :ID_CHARGEON
                      and ARTICUL = :ARTICUL
                      and ALC_CODE = :ALC_CODE)) then
          update EGAIS_REG2_SPEC_EXT
             set QUANTITY = QUANTITY + :Q
           where DOC_ID = :ID_CHARGEON
                 and ARTICUL = :ARTICUL
                 and ALC_CODE = :ALC_CODE;
        else
        begin
          POSC = POSC + 1;
          insert into EGAIS_REG2_SPEC_EXT (DOC_ID, ARTICUL, ALC_CODE, QUANTITY, IDENTITY)
               values (:ID_CHARGEON, :ARTICUL, :ALC_CODE, :Q, :POSC);
        end

        in autonomous transaction do
          insert into TMP_LOG (KIND, level, TEXT)
               values (1, 5, '   : / '||:ALC_CODE||'  '||doubletrunc(:Q,'0.00'));

        QUANTITY = QUANTITY + Q;
      end
    end
    --    .     ,        (    ).
  end

  ERROR_MSG = null;
  suspend;
end^

create or alter procedure OVS0_CYCLE_S_DOC (
    V_STAGE_ID T_FID)
returns (
    ID T_FID,
    XML_KIND T_STR30_NULL,
    NUM_LINE T_NUM_VALUE,
    TAG_KIND T_NUM_VALUE,
    TAG_NAME T_STR_VALUE,
    TAG_TEXT T_STR_VALUE,
    V_PAR1 T_STR_VALUE,
    V_PAR2 T_STR_VALUE,
    V_PAR3 T_STR_VALUE,
    V_PAR4 T_STR_VALUE,
    ID_TRUE T_FID)
AS
declare variable S varchar(255);
declare variable V_DATE date;
declare variable V_DBL double precision;
declare variable X_DOC_DATE date;
declare variable X_CLIENT_INDEX integer;
declare variable X_CLIENT2_INDEX integer;
declare variable X_DOCINDEX T_DOC_INDEX;
declare variable X_EXT_DOCINDEX T_EXT_DOC_INDEX;
declare variable X_EXT_DOC_DATE date;
declare variable H_LP integer;
declare variable S_ARTICUL T_ARTICUL_NULL;
declare variable S_QUANTITY double precision;
declare variable S_PRICERUB double precision;
declare variable S_NDS double precision;
declare variable S_COMMENT varchar(255);
declare variable GLN_LP varchar(30);
declare variable GLN_PL varchar(30);
declare variable GLN_CL varchar(30);
declare variable GLN_SENDER varchar(30);
declare variable GTIN varchar(30);
declare variable C_ARTICUL T_ARTICUL_NULL;
declare variable C_NAME varchar(80);
declare variable IS_OK integer;
declare variable V_ID integer;
declare variable V_I integer;
declare variable V_ATRATE varchar(20);
declare variable V_STATUS varchar(20);
declare variable v_ovs_kind integer;
declare variable v_ol integer;
declare variable v_deliv_date date;
declare variable v_show_t2q integer;
declare variable v_gtin_b varchar(1);
declare variable v_status_old varchar(20);
declare variable v_date_tn date;
declare variable v_num_tn varchar(256);
declare variable placeorder integer;
declare variable v_edi_gruz t_char;
declare variable v_consignee integer;
begin
  id_true = -1;
  /*    iCat EDI (      xml-)
           (   )
     id   , xml_kind  ,
     num_line    (    xml-)
     tag_kind - 0 -     ( ) ( tag_text   ),
                1 -  ,
                2 -  ,
                3 -  ,
                4 -      ( tag_name      tag_text )
     tag_name -  
     tag_text -  

     v_par...
        'v_'   xml-    tag_name
          : < >=< >
     ,  SMID=10666587    xml-  SMID="10666587"
        :  GTD=    xml-  GTD=""
          =           
  */

  --     
  if (exists(select 1 from OVS_KIND where id = 0 and share_status = 'T'))
    then select p.v_num from SESSIONS s
           inner join PARAMS p on p.session = s.id and class = 'OVS' and name = 'OvsStage'
           where cur_connect_id = current_connection
         into :v_ovs_kind;
    else v_ovs_kind = -1;

  v_gtin_b = 'F';
  select os.edi_gtin, os.edi_gruz from OVS_STAGE os where os.id = :v_ovs_kind rows 1 into :v_gtin_b, :v_edi_gruz;
  id = -1; is_ok = 0; --     
  for select 0, x.id, upper(x.xml_kind), x.doc_date, x.client_index, x.client2_index, coalesce(dh.legal_person, -1),
             x.docindex, x.ext_docindex, x.ext_doc_date,
             coalesce(s.articul,''), s.quantity, s.pricerub, s.nds,
             decode (s.taxhead, 1, '10', 2, '20', 5, 'NOT_APPLICABLE', 7, '18', 8, '0', 'NOT_APPLICABLE'),
             decode(x.post_status, 20, 'Original', 60, 'Canceled'),
             ol.order_dochead, p.delivery_date, s.comment, p.client_torg2, p.num_tn, p.date_tn,pp.order_num, p.consignee
        from OVS_OUT_DOC x
        left join DOCHEAD_ORDER_LINK ol on ol.in_dochead = x.id
        left join DOCHEAD_PARAMS p on p.dochead = x.id
        left join DOCSPEC s on s.id_dochead = x.id
        left join DOCHEAD dh on dh.id_dochead = s.id_dochead
        left join PLACEPRIORITY pp on pp.placeid = x.client2_index
        where x.post_status in (20,60) and x.xml_kind > '' and
              (s.articul is null or cmp_dbl_e(s.quantity, 0) > 0)
      union --        
      select 1, -1, null, null, null, null, null,
             null, null, null,
             null, null, null, null,
             'NOT_APPLICABLE',
             'Original',
             null, null, null, null, null, null,0, null
        from RDB$DATABASE
      order by 1,3,5,2,14 -- xml_kind,doc_date,id,pos_number
      into :v_i, :v_id, :s, :x_doc_date, :x_client_index, :x_client2_index, :h_lp,
           :x_docindex, :x_ext_docindex, :x_ext_doc_date,
           :s_articul, :s_quantity, :s_pricerub, :s_nds,
           :v_atrate,
           :v_status,
           :v_ol, :v_deliv_date, :s_comment, :v_show_t2q, :v_num_tn, :v_date_tn, :placeorder, :v_consignee
  do begin
    if (v_id <> -1 and s = 'RECADV') then
      if (v_show_t2q = 0)
            then select :s_quantity - coalesce(sum(t2.q_defect + t2.q_break + t2.q_good_date + t2.q_shortage - t2.q_surplus), 0)
                   from DOCSPEC_TORG2 t2
                   where t2.dochead = :v_id and t2.articul = :s_articul
                 into :s_quantity;
    v_atrate = replace(v_atrate, ' ', '');
    --      
    v_par1 = ''; v_par2 = ''; v_par3 = ''; v_par4 = ''; tag_text = '';

    -- tag_kind  tag_name     suspend
    --  
    if (id <> v_id) then begin

      if (id <> -1 and is_ok = 1) then begin --    
        begin --   when -   ,      
          id_true = id;
            if (not exists(select 1 from DOCHEAD_OVS
                           where dochead = :id and ovs_kind = :v_ovs_kind and post_status in (38,61,30))) then begin
            if (xml_kind = 'ORDERS') then begin
              if (v_status_old = 'Canceled')
                then update or insert into DOCHEAD_OVS(dochead, post_status, ovs_kind) values(:id, 61, :v_ovs_kind);
                else update or insert into DOCHEAD_OVS(dochead, post_status, ovs_kind) values(:id, 30, :v_ovs_kind);
            end else update or insert into DOCHEAD_OVS(dochead, post_status, ovs_kind) values(:id, 30, :v_ovs_kind);
          end
          tag_kind = 3; tag_name = 'lineItems'; suspend; num_line = num_line + 1; -- </lineItems>
          if (xml_kind = 'ORDERS')
            then tag_name = 'order';
            else if (xml_kind = 'RECADV') then tag_name = 'receivingAdvice';
          suspend; num_line = num_line + 1;                                    -- </order>
          tag_name = 'eDIMessage'; suspend; num_line = num_line + 1; -- </eDIMessage>
          --  - 
        end
        when any do begin
          --     -     
          tag_kind = 4; tag_name = x_docindex || '  ' || datetostr('DD.MM.YYYY', x_doc_date);
          tag_text = '   ';  id_true = id;
          suspend; num_line = num_line + 1; tag_text = ''; --   
        end
      end

      --    
      id = :v_id; xml_kind = s; num_line = 1; --  s  v_id   
      gln_lp = ''; gln_pl = ''; gln_cl = ''; gln_sender = '';
      v_status_old = v_status;

      if (id <> -1) then begin
        --    
        v_id=-1;
        if (v_edi_gruz='T') then
        begin
          v_id = v_consignee;
          if (v_id is null) then
            v_id = -1;
        end
        if (v_id=-1) then
        begin
          v_id = h_lp; -- gln_lp - sender gln . ,      .   ,     
          if (v_id = -1) then select id from GET_LEGAL_PERSON_FROM_PLACE(:x_client2_index) into :v_id;
          if (v_id = -1) then v_id = x_client2_index;
        end
        select sender_gln from OVS_STAGE where id = :v_stage_id into :gln_sender;
        select substring(trim(coalesce(paramvalue, '')) from 1 for 13)
          from CLIENTPARAMS where client_id = :v_id and paramtype = 6
        into :gln_lp;
        select substring(trim(coalesce(paramvalue, '')) from 1 for 13)
          from CLIENTPARAMS where client_id = :x_client2_index and paramtype = 6
        into :gln_pl;
        select substring(trim(coalesce(paramvalue, '')) from 1 for 13)
          from CLIENTPARAMS where client_id = :x_client_index and paramtype = 6
        into :gln_cl;

      end

      if  (((xml_kind = 'ORDERS' and v_deliv_date is not null) or (xml_kind <> 'ORDERS')) and
          ((v_ol is not null or xml_kind = 'ORDERS') and
          gln_lp > '' and gln_cl > '' and gln_pl > '' and
          ((xml_kind = 'ORDERS' or xml_kind = 'RECADV' and v_num_tn is not null and v_num_tn <> '') or
           (xml_kind <> 'RECADV' and x_ext_doc_date is not null and x_ext_docindex is not null and x_ext_docindex <> '')))) then begin
        is_ok = 1; --   GLN   .      
        if (xml_kind = 'RECADV') then begin
          --     v_id  v_date
          v_id = null; v_date = null;
          select order_dochead from DOCHEAD_ORDER_LINK where in_dochead = :id into :v_id;
          if (v_id is not null) then select doc_date from DOCHEAD where id_dochead = :v_id into :v_date;
          --      ?
        end

        tag_kind = 0; tag_name = 'eDIMessage';
        s = id || '_' || datetostr('YYYYMMDDHHNNSS', 'now');
        tag_text = xml_kind || '_' || s; v_par1 = 'id=' || s;
        suspend; num_line = num_line + 1; tag_text = ''; v_par1 = ''; -- <eDIMessage id="12045_20120622154132555">
        tag_kind = 2; tag_name = 'interchangeHeader';
        suspend; num_line = num_line + 1;            -- <interchangeHeader>
        --   
        tag_kind = 1; tag_name = 'sender'; tag_text = gln_sender;
        suspend; num_line = num_line + 1;              -- <sender>4607195499990</sender>
        tag_kind = 1; tag_name = 'recipient'; tag_text = gln_cl;
        suspend; num_line = num_line + 1;              -- <recipient>4049111000000</recipient>
        tag_kind = 1; tag_name = 'documentType'; tag_text = xml_kind;
        suspend; num_line = num_line + 1; tag_text = ''; -- <documentType>ORDERS</documentType>
        tag_kind = 3; tag_name = 'interchangeHeader';
        suspend; num_line = num_line + 1;            -- </interchangeHeader>
        if (xml_kind = 'ORDERS') then begin
          tag_kind = 2; tag_name = 'order';
          v_par1 = 'number=' || id; v_par2 = 'date=' || datetostr('YYYY-MM-DD', coalesce(x_doc_date,current_timestamp)); v_par3 = 'status='||v_status;
          suspend; num_line = num_line + 1; v_par1 = ''; v_par2 = ''; v_par3 = ''; -- <order number="12045" date="2012-01-31">
        end else
        if (xml_kind = 'RECADV') then begin
          tag_kind = 2; tag_name = 'receivingAdvice';
          v_par1 = 'number=' || id; v_par2 = 'date=' || datetostr('YYYY-MM-DD', coalesce(x_doc_date,current_timestamp));
          suspend; num_line = num_line + 1;                    -- <receivingAdvice number="12047" date="2012-01-31">
          if (v_id is not null) then begin
            tag_kind = 1; tag_name = 'originOrder';
            v_par1 = 'number=' || v_id; v_par2 = 'date=' || datetostr('YYYY-MM-DD', coalesce(v_date,current_timestamp));
            suspend; num_line = num_line + 1;                  -- <originOrder number="12045" date="2012-01-31"/>
          end
          if (v_num_tn is not null and v_num_tn <> '') then begin
            tag_kind = 1; tag_name = 'despatchIdentificator';
            v_par1 = 'number=' || v_num_tn;
            if (v_date_tn is not null) then v_par2 = 'date=' || datetostr('YYYY-MM-DD', coalesce(v_date_tn,current_timestamp));
            suspend; num_line = num_line + 1; v_par1 = ''; v_par2 = '';        -- <despatchIdentificator number="des12045"/>
          end
          tag_kind = 1; tag_name = 'status'; tag_text = v_status;
          suspend; num_line = num_line + 1;  --<status>
        end
        if (xml_kind = 'ORDERS') then begin
          tag_kind = 1; tag_name = 'comment'; tag_text = x_docindex;
          suspend; num_line = num_line + 1;  --<comment>
          if (exists(select 1 from CONFIG where PARAMNAME='UsePriorityPlaces' and boolparam='T')) then begin
            tag_kind = 1; tag_name = 'blanketOrderIdentificator'; v_par1 = 'number=' || placeorder; tag_text = '';
            suspend; num_line = num_line + 1; v_par1 = '';
          end  --<blanketOrderIdentificator>
        end
        tag_kind = 2; tag_name = 'seller'; tag_text = '';
        suspend; num_line = num_line + 1; -- <seller>
        tag_kind = 1; tag_name ='gln'; tag_text = gln_cl;
        suspend; num_line = num_line + 1;              -- <gln>4049111000000</gln>
        tag_kind = 1; tag_name ='additionalIdentificator'; tag_text=x_client_index;
        suspend; num_line = num_line + 1; tag_text = ''; -- <additionalIdentificator>21546</additionalIdentificator>
        tag_kind = 3; tag_name ='seller';
        suspend; num_line = num_line + 1; -- </seller>
        tag_kind = 2; tag_name = 'buyer';
        suspend; num_line = num_line + 1; -- <buyer>
        tag_kind = 1; tag_name = 'gln'; tag_text = gln_lp;
        suspend; num_line = num_line + 1; tag_text = ''; -- <gln>4607195499990</gln>
        tag_kind = 3; tag_name ='buyer';
        suspend; num_line = num_line + 1; -- </buyer>
        if (gln_pl > '' or gln_cl > '') then begin
          tag_kind = 2; tag_name = 'deliveryInfo';
          suspend; num_line = num_line + 1; -- <deliveryInfo>
          if (xml_kind = 'ORDERS') then s = 'requestedDeliveryDateTime';
            else if (xml_kind = 'RECADV')
                   then s = 'receptionDateTime';
                   else s = '';
          if (s > '') then begin
            tag_kind = 1; tag_name = s;
            if (xml_kind = 'ORDERS')
              then tag_text = datetostr('YYYY-MM-DD', coalesce(v_deliv_date,current_timestamp))||'T00:00:00.000Z'; --
              else tag_text = datetostr('YYYY-MM-DD', coalesce(x_doc_date,current_timestamp))||'T00:00:00.000Z'; --
            suspend; num_line = num_line + 1; tag_text = ''; -- <requestedDeliveryDateTime>2012-02-05T19:00:00.000Z</requestedDeliveryDateTime>
          end
          if (gln_pl > '') then begin
            tag_kind = 2; tag_name = 'shipTo';
            suspend; num_line = num_line + 1; -- <shipTo>
            tag_kind = 1; tag_name = 'gln'; tag_text = gln_pl;
            suspend; num_line = num_line + 1; tag_text = ''; -- <gln>4607195499000</gln>
            tag_kind = 3; tag_name = 'shipTo';
            suspend; num_line = num_line + 1; -- </shipTo>
          end
          if (gln_cl > '') then begin
            tag_kind = 2; tag_name = 'shipFrom';
            suspend; num_line = num_line + 1; -- <shipFrom>
            tag_kind = 1; tag_name = 'gln'; tag_text = gln_cl;
            suspend; num_line = num_line + 1; tag_text = ''; -- <gln>4607195499000</gln>
            tag_kind = 3; tag_name = 'shipFrom';
            suspend; num_line = num_line + 1; -- </shipFrom>
          end
          tag_kind = 3; tag_name = 'deliveryInfo';
          suspend; num_line = num_line + 1; -- </deliveryInfo>
        end
        tag_kind = 2; tag_name = 'lineItems';
        suspend; num_line = num_line + 1; -- <lineItems>
      end else begin
        is_ok = 0; --   GLN   .       
        if (id <> -1) then begin s = '';
          if (gln_lp = '') then s = '  GLN  (' || v_id || ')';
          if (gln_cl = '') then
            if (s = '')
              then s = '  GLN  (' || x_client_index || ')';
              else s = s || ',   GLN  (' || x_client_index || ')';
          if (gln_pl = '') then
            if (s = '')
              then s = '  GLN ';
              else s = s || ',   GLN ';

          if (xml_kind = 'RECADV') then begin
            if (v_num_tn is null or v_num_tn = '') then
              if (s = '')
                then s = '   ';
                else s = s || ',    ';
          end

          if (xml_kind = 'ORDERS' and v_deliv_date is null) then begin
            if (s = '')
                then s = '   ' || x_docindex || '  ' || datetostr('DD.MM.YYYY', x_doc_date);
                else s = s || ',    ' || x_docindex || '  ' || datetostr('DD.MM.YYYY', x_doc_date);
          end

          if (xml_kind <> 'ORDERS' and xml_kind <> 'RECADV') then begin
            if (x_ext_doc_date is null) then
              if (s = '')
                then s = '    ';
                else s = s || ',     ';
            if (x_ext_docindex is null or x_ext_docindex = '') then
              if (s = '')
                then s = '    ';
                else s = s || ',     ';
          end

          if (xml_kind = 'RECADV' and v_ol is null) then
            if (s = '')
              then s = '     ';
              else s = s || ',      ';

          tag_kind = 4; tag_name = x_docindex || '  ' || datetostr('DD.MM.YYYY', x_doc_date); tag_text = s;  id_true = id;
          suspend; num_line = num_line + 1; tag_text = ''; --   

          begin
            update or insert into DOCHEAD_OVS(dochead, post_status, ovs_kind)
              values(:id, 38, :v_ovs_kind);--values(:id, :x_i_param1, :v_ovs_kind);
          end
          when any do begin
            --     -     
            tag_kind = 4; tag_name = x_docindex || '  ' || datetostr('DD.MM.YYYY', x_doc_date);
            tag_text = '   ';  id_true = id;
            suspend; num_line = num_line + 1; tag_text = ''; --   
          end
        end
      end
    end

    --   
    -- s_quantity   0 -  2 (  )
    if (is_ok = 1 and s_articul > '' and cmp_dbl_e(s_quantity, 0) = 1) then begin
      --     
      gtin = ''; c_articul = ''; c_name = '';
      select substring(trim(coalesce(gtin, '')) from 1 for 14),
             substring(clarticul from 1 for 17), name
        from CLCARDSCLA where client_index = :x_client_index and articul = :s_articul
        order by asrt
        rows 1
      into :gtin,
            :c_articul, :c_name;
      if (exists(select 1 from CARDSCLA c
                   inner join MESURIMENT m on m.id_mesuriment = c.mesuriment and m.is_weight = 'T'
                 where c.articul = :s_articul))
        then s = 'KGM'; else s = 'PCE';

      if (gtin = '' and v_gtin_b = 'F') then begin
        is_ok = 0; --   GTIN            
        tag_kind = 4; tag_name = x_docindex || '  ' || datetostr('DD.MM.YYYY', x_doc_date);
        tag_text = '  GTIN    (' || s_articul || ')'; id_true = id;
        suspend; num_line = num_line + 1; tag_text = ''; --   
        begin
          update or insert into DOCHEAD_OVS(dochead, post_status, ovs_kind) values(:id, 38, :v_ovs_kind);--values(:id, :x_i_param1, :v_ovs_kind);
        end
        when any do begin
          --     -     
          tag_kind = 4; tag_name = x_docindex || '  ' || datetostr('DD.MM.YYYY', x_doc_date);
          tag_text = '   ';  id_true = id;
          suspend; num_line = num_line + 1; tag_text = ''; --   
        end
      end else begin
        --   GTIN 
        tag_kind = 2; tag_name = 'lineItem';
        suspend; num_line = num_line + 1; -- <lineItem>
        --if (gtin <> '') then begin
          tag_kind = 1; tag_name = 'gtin'; tag_text = gtin;
          suspend; num_line = num_line + 1; -- <gtin>00012000245114</gtin>
       -- end
        if (char_length(s_articul) < 18) then begin
          tag_kind = 1; tag_name = 'internalBuyerCode'; tag_text = s_articul;
          suspend; num_line = num_line + 1; -- <internalBuyerCode>00002</internalBuyerCode>
        end

        if (c_articul > '' and char_length(c_articul) < 18) then begin
          tag_kind = 1; tag_name = 'internalSupplierCode'; tag_text = c_articul;
          suspend; num_line = num_line + 1; -- <internalSupplierCode>sa22</internalSupplierCode>
        end
        if (v_gtin_b = 'T') then
        begin
          c_name = trim(coalesce(c_name,''));
          if (c_name = '') then
            select cc.name from cardscla cc where cc.articul=:s_articul into :c_name;
        end
        if (c_name > '') then begin
          tag_kind = 1; tag_name = 'description'; tag_text = c_name;
          suspend; num_line = num_line + 1; -- <description> ""</description>
        end
        v_par1 = 'unitOfMeasure=' || s;
        if (xml_kind = 'ORDERS')
          then s = 'requestedQuantity';
          else if (xml_kind = 'RECADV')
                 then s = 'acceptedQuantity';
                 else s = 'Quantity';
        tag_kind = 1; tag_name = s; tag_text = trim(numtostr('%12.3f', s_quantity));
        suspend; num_line = num_line + 1; v_par1 = ''; -- <requestedQuantity unitOfMeasure="PCE">12</requestedQuantity>
        v_dbl = s_quantity * s_pricerub - s_nds;
        tag_kind = 1; tag_name = 'comment'; tag_text = trim(s_comment);
        suspend; num_line = num_line + 1; -- <comment>fdfd</comment>
        tag_kind=1; tag_name = 'netPrice'; tag_text = trim(numtostr('%15.4f', v_dbl / s_quantity));
        suspend; num_line = num_line + 1; -- <netPrice>12.4324</netPrice>
        tag_kind = 1; tag_name = 'netPriceWithVAT'; tag_text = trim(numtostr('%15.4f', s_pricerub));
        suspend; num_line = num_line + 1; -- <netPriceWithVAT>12.4324</netPriceWithVAT>
        tag_kind = 1; tag_name = 'netAmount'; tag_text = trim(numtostr('%15.4f', v_dbl));
        suspend; num_line = num_line + 1; -- <netAmount>149.1888</netAmount>
        tag_kind = 1; tag_name = 'vATRate'; tag_text = v_atrate; --  
        suspend; num_line = num_line + 1; -- <vATRate>NOT_APPLICABLE</vATRate>
        if (v_atrate <> 'NOT_APPLICABLE') then begin
          tag_kind = 1; tag_name = 'vATAmount'; tag_text = trim(numtostr('%15.4f', s_nds)); --    ,      є
          suspend; num_line = num_line + 1; -- <vATAmount>12.23</vATAmount>
        end
        tag_kind = 1; tag_name = 'amount'; tag_text = trim(numtostr('%15.4f', s_quantity * s_pricerub)); --     
        suspend; num_line = num_line + 1; -- <amount>160.34</amount>
        tag_kind = 3; tag_name = 'lineItem'; tag_text = '';
        suspend; num_line = num_line + 1; -- </lineItem>
      end
    end
  end

  for select distinct dh.id_dochead
    from OVS_OUT_DOC x
    inner join DOCHEAD_ORDER_LINK ol on ol.order_dochead = x.id
    inner join DOCHEAD dh on dh.id_dochead = ol.in_dochead and dh.accept = 'F'
    where upper(x.xml_kind) = 'ORDERS' and x.post_status = 60
    into :v_id
  do delete from DOCHEAD dh where dh.id_dochead =:v_id;

  v_i = v_i; --      ,    -    
end^

create or alter procedure ACT_WRITEOFF_CORRECTIONS (
    ACT_HEAD T_DOC)
returns (
    ID_DOCHEAD_IN T_DOC,
    ID_DOCHEAD_OUT T_DOC,
    ERR_STR T_STR_VALUE)
AS
declare variable manager integer;
declare variable act_date date;
declare variable filial integer;
declare variable doc_kind integer;
declare variable doc_type integer;
declare variable operation integer;
declare variable client_act integer;
declare variable client_corr integer;
declare variable place integer;
declare variable shop integer;
declare variable doc_number integer;
declare variable doc_index t_doc_index;
declare variable doc_postfix varchar(2);
declare variable act_index t_doc_index;
declare variable articul t_articul_null;
declare variable pos_number integer;
declare variable art_list varchar(255);
declare variable mesuriment integer;
declare variable rz integer;
declare variable quantity  double precision;
declare variable price_rub double precision;
declare variable price_cur double precision;
declare variable asrt integer;
declare variable taxhead integer;
declare variable barcode t_barcode_null;
declare variable comment t_comment;
declare variable made_corr_docs integer;
begin
  /*
  16.12.2014 by ANT
  SM-1434 "    "

         ACT_WRITEOFF_ARTICUL  
   TMP_WRITEOFF   ,      .

             -
       .

    ,    .
   TMP_WRITEOFF     ,      ,
      .

     ,    
      .   ,    
  ( ).

  07.05.15 by ANT SM-1595
      
*/

  err_str = null; id_dochead_in = null; id_dochead_out = null; pos_number = 0;

  select doc_date, dochead_filialindex, client_index, client2_index, manager, shopindex, docindex
    from DOCHEAD
    where id_dochead = :act_head
  into :act_date, :filial, :client_act, :place, :manager, :shop, :act_index;

  --  :      
  --      ,   - .
  --    - 
  art_list = '';
  select left(list(ds.articul, ', '), 200)
    from DOCSPEC ds
    left join ACT_WRITEOFF_CORRECTIONS_LPRICE(ds.articul, :filial, :shop) gp on 1 = 1
    where ds.id_dochead = :act_head and coalesce(gp.price_rub, 0) = 0
  into :art_list;

  --     ,    , ..
  --       .
  if (char_length(art_list) > 0) then begin
    err_str = '      : ' || ascii_char(13) || :art_list;
    if (char_length(err_str) > 250) then err_str = left(err_str, 250) || '...';
    suspend;
    exit;
  end

  --   
  made_corr_docs = 0;--   .  -    
  for select ds.articul, ds.rz, ds.mesuriment, ds.quantity, gp.price_rub, gp.price_cur,
             ds.taxhead, ds.barcode, ds.comment
    from DOCSPEC ds
    left join CARDSCLA cs on ds.articul = cs.articul
    left join CARDTYPES ct on cs.cardtype = ct.id_cardtype
    left join ACT_WRITEOFF_CORRECTIONS_LPRICE(ds.articul, :filial, :shop) gp on 1 = 1
    where ds.id_dochead = :act_head and ct.is_matirial = 'T'
    into :articul, :rz, :mesuriment, :quantity, :price_rub, :price_cur,
         :taxhead, :barcode, :comment
  do begin
    for select a.asrt, a.quantity - lq.quantity
      from VW_ASRT_DOCSPEC(:act_head, :articul, :rz, :mesuriment, :quantity) a
      left join ACT_LINK_QUANTITY(:act_head, :articul, a.asrt) lq on 1 = 1
      into :asrt, :quantity
    do begin
      if (cmp_dbl_e(quantity, 0) = 1) then begin --  
        --    ,     
        made_corr_docs = 1;
        if (id_dochead_in is null) then begin
          --   
          select doctype, operation, client_index
            from DOCTYPE_FILIAL
            where kind = 31 --  
                  and dockind = 0 -- 
                  and filial_index = :filial
          into :doc_type, :operation, client_corr;

          doc_number = ascii_val('a') - 1;
          --   
          while (1 = 1) do begin
            doc_number = doc_number + 1;
            if (doc_number <= ascii_val('z'))
              then doc_postfix = ascii_char(doc_number);
              else doc_postfix = ascii_char(ascii_val('a') - 1 + div(doc_number, ascii_val('z'))) || ascii_char(ascii_val('a') - 1 + mod(doc_number, ascii_val('z')));
            if (char_length(act_index || doc_postfix) > 10) then  begin
              exception e_lenght_docindex;
              exit;
            end else doc_index = act_index || doc_postfix;
            if (not exists(select 1 from DOCHEAD where shopindex = :shop and docindex = :doc_index))
              then break;
          end

          doc_kind = 0; id_dochead_in = gen_id(dochead_gen, 1);
          -- attach = 0,          ,
          --          .
          insert into DOCHEAD (id_dochead, docindex, shopindex, dochead_filialindex,
                               doctype, dockind, doc_date, client_index, client2_index,
                               operation, manager, attach)
            values (:id_dochead_in, :doc_index, :shop, :filial,
                    :doc_type, :doc_kind, :act_date, :client_act, :place,
                    :operation, :manager, 0);
        end --     
        --       
        pos_number = pos_number + 1;
        insert into DOCSPEC (id_dochead, articul, pos_number, quantity, pricerub, pricecur,
                             mesuriment, rz, pricerub_1, pricecur_1, taxhead, barcode, comment)
          values (:id_dochead_in, :articul, :pos_number, :quantity, :price_rub, :price_cur,
                  :mesuriment, :rz, :price_rub, :price_cur, :taxhead, :barcode, :comment);
        --     ,       
        insert into TMP_WRITEOFF (acthead, articul, asrt, outdochead, indochead, quantity, pricerub, pricecur)
          values (:act_head, :articul, :asrt, -1, :id_dochead_in, :quantity, :price_rub, :price_cur);
      end
    end
  end
  --    ,  . -   .
  if (made_corr_docs = 0) then begin
    suspend;
    exit;
  end

  --   

  --  
  select doctype, operation, client_index
    from DOCTYPE_FILIAL
    where kind = 31 --  
          and dockind = 1 -- 
          and filial_index = :filial
  into :doc_type, :operation, :client_corr;

  --      ,      (   ).
  if (client_corr is null) then client_corr = client_act;

  --   
  while (1 = 1) do begin
    doc_number = doc_number + 1;
    if (doc_number <= ascii_val('z'))
      then doc_postfix = ascii_char(doc_number);
      else doc_postfix = ascii_char(ascii_val('a') - 1 + div(doc_number, ascii_val('z'))) || ascii_char(ascii_val('a') - 1 + mod(doc_number, ascii_val('z')));
    if (char_length(act_index || doc_postfix) > 10) then begin
      exception e_lenght_docindex;
      exit;
    end else doc_index = act_index || doc_postfix;
    if (not exists(select 1 from DOCHEAD where shopindex = :shop and docindex = :doc_index))
      then break;
  end

  doc_kind = 1; id_dochead_out = gen_id(dochead_gen, 1);
  insert into DOCHEAD (id_dochead, docindex, shopindex, dochead_filialindex,
                       doctype, dockind, doc_date, client_index, client2_index,
                       operation, manager)
    values (:id_dochead_out, :doc_index, :shop, :filial,
            :doc_type, :doc_kind, 'today', :client_corr, :place,
            :operation, :manager);

  --     - --   
  insert into DOCSPEC (id_dochead, articul, pos_number, quantity, pricerub, pricecur,
                       mesuriment, rz, pricerub_1, pricecur_1, taxhead, barcode, comment)
    select :id_dochead_out, articul, pos_number, quantity, pricerub, pricecur,
           mesuriment, rz, pricerub_1, pricecur_1, taxhead, barcode, comment
      from DOCSPEC
    where id_dochead = :id_dochead_in;

  --    (   ACT_WRITEOFF_DONE    )
  update DOCHEAD set doc_state = -2, moddate = moddate + 0.00001 where id_dochead = :id_dochead_in;

  --      
  insert into DOCHEAD_LINK_CORR (dochead, basedochead) values (:id_dochead_in, :act_head);
  insert into DOCHEAD_LINK_CORR (dochead, basedochead) values (:id_dochead_out, :act_head);

  suspend;
end^

set term ; ^


commit work;
