-- S-Market: "  "
--    "-", 2019 


SET TERM ^ ;

create or alter procedure RPT_DEBTSAE_TEST (
    REPORT_ID T_FID,
    OWNER_ID T_FID,
    DATE_FIRST T_DATE_NULL,
    DATE_LAST T_DATE_NULL,
    ALL_MANAGERS T_INT_VALUE,
    ALL_PAYDOCS T_INT_VALUE,
    ALL_RETURNS T_INT_VALUE,
    GET_ON_START T_INT_VALUE,
    ZERO T_FLOAT,
    INN_ T_INT_VALUE,
    EXCLUDE_RETURNS T_INT_VALUE,
    PREPAYMENT T_INT_VALUE,
    PAYMENT_DELAY T_INT_VALUE)
returns (
    CLIENT_ID T_FID,
    CLIENT_NAME T_STRING128_NULL,
    CLIENT_PHONE T_NAME_NULL,
    DOC_HEAD T_DOC,
    DOC_INDEX T_DOC_INDEX,
    DOC_DATE T_DATE_NULL,
    ACCOUNT_INDEX T_DOC_INDEX,
    PAYMENT_KIND T_FULL_NAME_NULL,
    SUM_RUB T_MONEY_NULL,
    PAYED_RUB T_MONEY_NULL,
    DEBT_RUB T_MONEY_NULL,
    SUM_CUR T_MONEY_NULL,
    PAYED_CUR T_MONEY_NULL,
    DEBT_CUR T_MONEY_NULL,
    MANAGER T_FULL_NAME_NULL,
    DEBT_DATE T_DATE_NULL,
    REGISTERED T_INT_VALUE,
    HIDE T_INT_VALUE)
AS
declare variable debt_date2      date;
declare variable visible         integer;
declare variable acc_dochead     integer;
declare variable id_manager      integer;
declare variable id_place        integer;
declare variable id_operation    integer;
declare variable li_place        integer;
declare variable li_client       integer;
declare variable li_manager      integer;
declare variable li_operation    integer;
declare variable sum_rub_period  double precision;
declare variable sum_cur_period  double precision;
declare variable sum_rub_period1 double precision;
declare variable sum_cur_period1 double precision;
declare variable sum_rub_period2 double precision;
declare variable sum_cur_period2 double precision;
declare variable sum_rub_period3 double precision;
declare variable sum_cur_period3 double precision;
declare variable ret_rub_period1 double precision;
declare variable ret_cur_period1 double precision;
declare variable ret_rub_period2 double precision;
declare variable ret_cur_period2 double precision;
declare variable ret_rub_period3 double precision;
declare variable ret_cur_period3 double precision;
declare variable ret_rub         double precision;
declare variable ret_cur         double precision;
declare variable ret_registered  integer;
declare variable doc_rub         double precision;
declare variable doc_cur         double precision;
declare variable doc_registered  integer;
declare variable ret_client_id   integer;
declare variable ret_client_inn  t_inn;
declare variable ret_client_name varchar(100);
declare variable ret_doc_index   t_doc_index;
declare variable ret_doc_date    date;
declare variable ret_doc_head    integer;
declare variable client_id_      integer;
declare variable client_name_    varchar(100);
declare variable doc_index_      t_doc_index;
declare variable doc_date_       date;
declare variable sum_rub_        double precision;
declare variable debt_rub_       double precision;
declare variable sum_cur_        double precision;
declare variable debt_cur_       double precision;
declare variable debt_date_      date;
declare variable ret_id_manager  integer;
declare variable doc_head_       integer;
declare variable client_inn      t_inn;
declare variable payment_id      integer;
declare variable total_rub       double precision;
declare variable total_cur       double precision;
declare variable account_index_  t_doc_index;
declare variable doc_id          integer;
declare variable doc_kind        integer;
begin
  /*   
     report_id -1; owner_id -  user;
           (, , )
     date_first date_last  
     all_managers     
     all_paydocs   
     get_on_start    
     zero      (    )


           (     )

     doc_head, doc_index, doc_date, client_id, client_name, manager -  

     account_index -  ,      ( )
     sum_rub, sum_cur     -    (dochead.totalrub, dochead.totalcur)
     payed_rub, payed_cur -     (  ..               ,     )

     debt_rub, debt_cur   -   .. =    -    
     debt_date -        ..         
                     -       
                    -    

     hide -           
  */

  select handle from RPT_LIST_PLACE_CREATE(:report_id, :owner_id) into :li_place;
  select handle from RPT_LIST_CLIENT_CREATE(:report_id, :owner_id) into :li_client;
  select handle from RPT_LIST_MANAGER_CREATE(:report_id, :owner_id) into :li_manager;
  select handle from RPT_LIST_OPERATION_CREATE(:report_id, :owner_id) into :li_operation;

  --     -        
  --      ,    
  for select dh.id_dochead, dh.doc_date, dh.docindex, dh.totalrub, dh.totalcur,
             dh.manager, dh.client_index, dh.client2_index, dh.registered, dh.operation
    from DOCHEAD dh
    inner join OPERATIONS op on op.id_operation = dh.operation
    where dh.doc_date <= :date_last and (:get_on_start = 1 or dh.doc_date >= :date_first) and
          dh.accept = 'T' and dh.dockind = 1 and op.opertype = 0
    into :doc_head, :doc_date, :doc_index, :doc_rub, :doc_cur,
          :id_manager, :client_id, :id_place, :doc_registered, :id_operation
  do begin
    visible = 1; --    ,   
    if (all_managers <> 1 and listint_exists(li_manager, id_manager) = 0) then visible = 0;
    if (visible = 1 and listint_exists(li_client, client_id) = 0) then visible = 0;
    if (visible = 1 and listint_exists(li_place, id_place) = 0) then visible = 0;
    if (visible = 1 and listint_exists(li_operation, id_operation) = 0) then visible = 0;

--    visible = 1; --!

    if (visible = 1) then begin --      
      if (doc_date is null)
        then payment_kind = '<<    >>';
        else if (dateadd(3 year to :doc_date) < 'TODAY')
               then payment_kind = '     ';
               else if (datediff(year from :doc_date to cast('TODAY' as date)) >= :payment_delay)
                      then payment_kind = ' ';
                      else if (datediff(year from :doc_date to cast('TODAY' as date)) = 0)
                             then payment_kind = '  ';
                             else payment_kind = ' ';

      --  
      manager = null; client_name = null; debt_date = doc_date; account_index = '';

      /*1336 by ANT********************************
         : SM-1336       "  "
            " "     ,   ,
             ,   . */

      --   ,        .
      --  "retspec"       .

      ret_rub_period1 = 0; ret_cur_period1 = 0;
      ret_rub_period2 = 0; ret_cur_period2 = 0;
      ret_rub_period3 = 0; ret_cur_period3 = 0;

      for select r.dochead, r.pricerub, r.pricecur, r.doc_date, d.client_index, d.docindex,
                 d.registered, c.name_clients, c.inn_clients, d.manager
        from (select sum(r.pricerub * r.quantity) pricerub, sum(r.pricecur * r.quantity) pricecur, r.dochead, r.doc_date
                from RETSPEC r
                inner join OPERATIONS o on o.id_operation = r.operation and o.opertype = 1
                where r.outdochead = :doc_head and
                      (:all_returns = 1 or r.doc_date <= :date_last) and
                      listint_exists(:li_operation, r.operation) = 1
                group by dochead, doc_date) r
        left join DOCHEAD d on d.id_dochead = r.dochead
        left join CLIENTS c on c.id_clients = d.client_index
        into :ret_doc_head, :ret_rub, :ret_cur, :ret_doc_date, :ret_client_id, :ret_doc_index,
             :ret_registered, :ret_client_name, :ret_client_inn, :ret_id_manager
      do begin
        if (ret_doc_date < date_first) then begin --   
          ret_rub_period1 = ret_rub_period1 + ret_rub;
          ret_cur_period1 = ret_cur_period1 + ret_cur;
        end else
        if (exclude_returns = 1) then begin
          if (ret_doc_date > date_last) then begin --   
            ret_rub_period3 = ret_rub_period3 + ret_rub;
            ret_cur_period3 = ret_cur_period3 + ret_cur;
          end else begin --   
            --      
            ret_rub_period2 = ret_rub_period2 + ret_rub;
            ret_cur_period2 = ret_cur_period2 + ret_cur;
          end
        end else begin --    ,     
          --   exclude_returns = 0
          --     ,    
          account_index_ = account_index;
          sum_rub_ = sum_rub; sum_cur_ = sum_cur;
          doc_date_ = doc_date; client_id_ = client_id; client_name_ = client_name;
          doc_index_ = doc_index; debt_date_ = debt_date;
          debt_rub_ = debt_rub; debt_cur_ = debt_cur;
          doc_head_ = doc_head;
          payed_rub = null; payed_cur = null;
          debt_rub = -ret_rub; debt_cur = -ret_cur;
          account_index = null; doc_date = ret_doc_date; client_id = ret_client_id;
          manager = null;
          select name_user from USERS where id_user = :ret_id_manager into :manager;

          if (inn_ = 1 and ret_client_inn is not null and ret_client_inn <> '')
            then client_name = ret_client_name || ' ' || ret_client_inn;
            else if (inn_ = 1 and (ret_client_inn is null or ret_client_inn = ''))
                   then client_name = ret_client_name || '    ';
                   else client_name = ret_client_name;

          doc_head = ret_doc_head;
          doc_index = ret_doc_index;
          debt_date = doc_date;
          registered = ret_registered;
          hide = 0;
          suspend;

          doc_head = doc_head_; account_index = account_index_;
          sum_rub = sum_rub_; sum_cur = sum_cur_;
          doc_date = doc_date_; client_id = client_id_; client_name = client_name_;
          doc_index = doc_index_; debt_date = debt_date_;
          debt_rub = debt_rub_; debt_cur = debt_cur_;
        end
      end -- for

      --     (    ,      )
      doc_rub = doc_rub - ret_rub_period1 - ret_rub_period2 - ret_rub_period3;
      doc_cur = doc_cur - ret_cur_period1 - ret_cur_period2 - ret_cur_period3;

      /*********************************1336*/

      /*        3 
         1)   date_first
         2)    [date_first; date_last]
         3)   date_last (    all_paydocs=1) */
      sum_rub_period1 = 0; sum_cur_period1 = 0;
      sum_rub_period2 = 0; sum_cur_period2 = 0;
      sum_rub_period3 = 0; sum_cur_period3 = 0;

      -- 
      --      
      acc_dochead = null; debt_date2 = null;

      select min(a.accounthead)
        from DOCHEAD_ACCOUNT a
        join DOCHEAD d on d.id_dochead = a.dochead and
                          listint_exists(:li_operation, d.operation) = 1
        where a.dochead = :doc_head and a.is_active = 1
      into :acc_dochead;

      --  debt_date        
      if (acc_dochead is null)
        then select max(paydate) from PLANPAY where dochead = :doc_head into :debt_date2;
        else begin
          select docindex from DOCHEAD where id_dochead = :acc_dochead into :account_index;
          select max(paydate) from PLANPAY where dochead = :acc_dochead into :debt_date2;
        end

      if (debt_date2 is not null) then debt_date = debt_date2;

      --   
      for select ps.paymentrub, ps.paymentcur, ps.basedocdate
            from PAYSPEC ps --   
            join DOCHEAD d1 on d1.id_dochead = ps.basedochead
            where ps.dochead = :doc_head and ps.basedockind in (7, 12)
          union all
          select pns.paymentrub, pns.paymentcur, pns.paydocdate
            from paynaclspec pns --    
            join DOCHEAD d2 on d2.id_dochead = pns.paydochead
            join DOCHEAD d3 on d3.id_dochead = pns.accountdochead and
                               listint_exists(:li_operation, d3.operation) = 1
            where pns.dochead = :doc_head  and pns.paydockind in (7, 12)
        into :sum_rub_period, :sum_cur_period, :debt_date2
      do begin
        if (debt_date2 < date_first) then begin
          sum_rub_period1 = sum_rub_period1 + sum_rub_period;
          sum_cur_period1 = sum_cur_period1 + sum_cur_period; -- 1)   date_first
        end else
        if (debt_date2 > date_last) then begin
          sum_rub_period3 = sum_rub_period3 + sum_rub_period;
          sum_cur_period3 = sum_cur_period3 + sum_cur_period; -- 3)   date_last
        end else begin
          sum_rub_period2 = sum_rub_period2 + sum_rub_period;
          sum_cur_period2 = sum_cur_period2 + sum_cur_period; -- 2)    [date_first; date_last]
        end
      end

      --    
      if (doc_date < date_first) then hide = 1; else hide = 0;

      --      ,       
      --      ,              
      if (doc_date <= date_last and (get_on_start = 1 or debt_date >= date_first)) then begin
        --       
        if (all_paydocs = 1) then begin --        ,      
          payed_rub = sum_rub_period1 + sum_rub_period2 + sum_rub_period3;
          payed_cur = sum_cur_period1 + sum_cur_period2 + sum_cur_period3;
        end else begin --             
                       --             
          payed_rub = sum_rub_period1 + sum_rub_period2;
          payed_cur = sum_cur_period1 + sum_cur_period2;
        end

        --  
        debt_rub = doc_rub - payed_rub;
        debt_cur = doc_cur - payed_cur;

        if (debt_rub <= -zero or debt_rub >= zero) then begin
          select name_user from USERS where id_user = :id_manager into :manager;
          select (case
                    when :inn_ = 1 and inn_clients is not null and inn_clients <> ''
                      then name_clients || ' ' || inn_clients
                    when :inn_ = 1 and ((inn_clients is null) or (inn_clients = ''))
                      then name_clients || '    '
                    else name_clients
                  end),
                 tel_clients
            from CLIENTS
            where id_clients = :client_id
          into :client_name, :client_phone;

          sum_rub = doc_rub; sum_cur = doc_cur;
          registered = doc_registered;
          suspend;
          visible = 1;  --        
        end else visible = 0;--          
      end
    end
  end

  account_index = null; debt_date = null; debt_rub = null; debt_cur = null;
  payed_rub = null; payed_cur = null;
  hide = 0;

  --  . exclude_returns = 0 and get_on_first = 0
  --   ,     .
  --    ,   ,  .
  if (get_on_start = 0 and exclude_returns = 0) then begin
    for select r2.dochead, -r2.pricerub, -r2.pricecur, r2.doc_date, d.client_index, d2.docindex,
               d.registered, c.name_clients, c.inn_clients, d.manager, c.tel_clients
      from (select sum(r1.pricerub * r1.quantity) pricerub, sum(r1.pricecur * r1.quantity) pricecur, r1.dochead, r1.doc_date, r1.outdochead
              from RETSPEC r1
              join OPERATIONS o on o.id_operation = r1.operation and o.opertype = 1
              where r1.doc_date >= :date_first and (:all_returns = 1 or r1.doc_date <= :date_last) and
                    listint_exists(:li_operation, r1.operation) = 1
              group by dochead, doc_date, outdochead) r2
      join DOCHEAD d on d.id_dochead = r2.outdochead and d.doc_date < :date_first
      join DOCHEAD d2 on d2.id_dochead = r2.dochead
      left join CLIENTS c on c.id_clients = d.client_index
      into :doc_head, :sum_rub, :sum_cur, :doc_date, :client_id, :doc_index,
           :registered,  :client_name, :client_inn, :id_manager, :client_phone
    do begin
      if ((all_managers = 1 or listint_exists(li_manager, id_manager) = 1) and
          listint_exists(li_client, client_id) = 1 and
          listint_exists(li_place, id_place) = 1) then begin
        debt_rub = sum_rub;
        debt_cur = sum_cur;
        manager = null;
        select name_user from USERS where id_user = :id_manager into :manager;
        if (inn_ = 1 and client_inn is not null and client_inn <> '')
          then client_name = client_name || ' ' || client_inn;
          else if (inn_ = 1 and (client_inn is null or client_inn = ''))
                 then client_name = client_name || '    ';
        suspend;
      end
    end
  end

  -- 
  if (prepayment = 1) then begin
    client_phone = null;
    sum_rub = null; sum_cur = null;
    payed_rub = null; payed_cur = null;
    debt_rub = null; debt_cur = null;
    manager = null; registered = null; doc_date = null;
    id_manager = null; id_place = null;
    hide = 0;
    doc_index = '';
    payment_kind = '<   >';
  
    --    
    for select dh.id_dochead, dh.totalrub, dh.totalcur, dh.client_index, dh.doc_date
      from DOCHEAD dh
      where dh.DOCKIND in (7,12) and --  
            dh.accept = 'T' and dh.doc_date <= :date_last and
            (:get_on_start = 1 or dh.doc_date >= :date_first) and
            listint_exists(:li_client, dh.client_index) = 1
      into :payment_id, :total_rub, :total_cur, :client_id, :debt_date
    do begin
      --    
      select case
               when :inn_ = 1 and inn_clients is not null and inn_clients <> ''
                 then name_clients || ' ' || inn_clients
               when :inn_ = 1 and (inn_clients is null or inn_clients = '')
                 then name_clients || '    '
               else name_clients
             end,
             tel_clients
        from CLIENTS
        where id_clients = :client_id
      into :client_name,
           :client_phone;

      --  ,     (.   . )
      for select ps.dochead, ps.dockind, sum(ps.paymentrub), sum(ps.paymentcur), dh.docindex
        from PAYSPEC ps
        join DOCHEAD dh on dh.id_dochead = ps.dochead and dh.accept = 'T'
        join OPERATIONS o on o.id_operation = dh.operation and o.opertype = 0
        where ps.basedochead = :payment_id and
              ps.dockind in (1,3) and --  ,  
              dh.doc_date <= :date_last and
              listint_exists(:li_operation, dh.operation) = 1 and
              listint_exists(:li_client, dh.client_index) = 1 and
              listint_exists(:li_place, dh.client2_index) = 1
        group by ps.dochead, ps.dockind, dh.docindex, dh.operation
        into :doc_id, :doc_kind, :doc_rub, :doc_cur, :account_index
      do begin
        if (doc_kind = 3) then begin --  
          --      ,    -  
          debt_rub = -doc_rub;
          debt_cur = -doc_cur;
          select -(:doc_rub - sum(ps.paymentrub)), -(:doc_cur - sum(ps.paymentcur))
            from PAYSPEC ps
            join DOCHEAD dh on dh.id_dochead = ps.dochead and dh.accept = 'T'
            join OPERATIONS o on o.id_operation = dh.operation and o.opertype = 0
            where ps.basedochead = :doc_id and
                  ps.dockind = 1 and --  
                  dh.doc_date <= :date_last and
                  listint_exists(:li_operation, dh.operation) = 1 and
                  listint_exists(:li_client, dh.client_index) = 1 and
                  listint_exists(:li_place, dh.client2_index) = 1
            group by ps.basedochead
          into :debt_rub, :debt_cur;

          if (debt_rub < -1e-2) then suspend;
        end
        total_rub = total_rub - doc_rub;
        total_cur = total_cur - doc_cur;
      end
      account_index = null;
      debt_rub = -total_rub; debt_cur = -total_cur;
      if (abs(debt_rub) > 1e-2) then suspend;
    end
  end
  execute procedure RPT_LISTS_FREE;
end^

grant execute on procedure rpt_debtsae_test to public^

set term ; ^

commit;

 
